
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		sButton, pButton;
	id		aSwitch;
	id		auShRow;
	id		basc;
	id		baux;
        id              colorMatrix;
	id		gridSize;
	id		haHa;
	id		keepTop;
	id		ascru,ruleSamples;
	id		wrule;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statProd;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;
	id		tiDat;
	id		valBx;
	id		wholePanel;
	
	id		theEvolView;
	id		theBlockView;
	id		theEntropyView;
	id		thePlaidView;
	id		theProbView;
	id		theShEvolView;
	id		theThEvolView;

	id		basinWindow;
	id		blockWindow;
	id		entropyWindow;
	id		evolWindow;
	id		keyWindow;
	id		probWindow;
	id		plaidWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	
	id		baysRule;
	id		baysCoef;
	id		bernEdge;
	id		bernGens;
	id		bernProb;
	id		probEI, probGens, probGrid;
	id		probComp, probLevel, probView;
	
	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
	
}

- printArhi:sender;
- clearScreen:sender;
- colorStates:sender;
- drawEvolu:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- nxasfreq;
- nxmoncar: (int) l;
- printEvolu:sender;
- showCursor:sender;
- showWrule:sender;
- setRule:sender;
- setTotalisticState:sender;
- prob:sender;
- makeline:sender;

- copyBlock:sender;
- copyNBlock:sender;
- copyProb:sender;
- copyEntropy:sender;
- copyPlaid:sender;
- copyStat:sender;
- copyShEvol:sender;
- copyThEvol:sender;

- probHowMany:sender;
- probSetEI:sender;
- probSetGen:sender;
- probSetBlk:sender;
- protectRule:sender;
- drawBlock:sender;
- drawNBlock:sender;
- drawProb:sender;
- drawPlaid:sender;
- drawStat:sender;

- printThEvol:sender;
- printEntropy:sender;
- printBlock:sender;
- printCycle:sender;
- printNBlock:sender;
- drawEntropy:sender;
- printPlain:sender;
- printProb:sender;
- printPlaid:sender;
- printStat:sender;
- printShEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end

/* end LCAUView.h */