
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau9h.h"
#import "nxardn9h.h"
// #import "nxprob9h.h"
// #import "nxcycl9h.h"
// #import "nxrijn7h.h"
#import <math.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern char ttrule[TS];
extern  int binrule[KK][KK];
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];

int    drawArhi=NO;
int    drawBack=YES;
int    drawBern=NO;
int    drawBasin=NO;
int    drawCross=NO;
int    drawEntpy=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawMeanF=NO;
int    draw2Block=NO;
int    drawNBlk=NO;
int    showStat=NO;
int    drawPlaid=NO;
int    drawview=0;

int    ardnl, ardnll;
int    probEIV='e';
int    probGenV='1';
int    probBlkV='1';

extern double blpr[KK];			/* probability from blocks	*/

double cubic[25][25][25];

extern NXColor colst[KK];

extern char colorwells[KK][6];

int    plaidline[2];			/* center for plaid radius contours */
extern double stt, sta[5][K3+1];

extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern float  getNumber(NXStream *stream);
extern int    getSeparator(NXStream *stream);

void     shortevolve(int m, int n);
double   tdist(int i, int j, int n);


/* from lcau.c */
void asctobin();
void evolve();
void onegen(int n);
void pgrid();
void pprob();
void ranblin(double p, double q, double r);
void ranlin();
void renewarry();
void savearry();
void xblnk();


#define MAXNUMLENGTH 50
#define DEFAULTRADIUS 1.0

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

  NXSetColor(colst[l]);

    switch (drawview) {
      case 0: PSrectfill((float)((i+2*j)%(2*AL)),2.0*(float)i,1.25,1.25); break;
      case 1: PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
      case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
      case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(2.5*(float)j,2.5*(float)i,9.6,9.6); break;
      case 7: PSrectfill((float)j,(float)i,3.125,3.125); break;
      default: break;}
      

}


/* m = line length; n = number of lines */
/* version de Mc */
/* esta rutina logra la simetria de una manera elegante, con el unico */
/* detalle que para la segunda generacion se desfasa un poco  */
/* hacia la derecha, el resto de las generaciones son correctas */ 
/*void shortevolve(m,n) int m, n; {
int i, j, k, l, o,k1;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
        k=j%2;  l=j/2;
        for (i=0; i<m; i++) videodot(5*j,5*i+2*k,arr1[(AL+i+o-l-k)%AL]);
        onegen(AL);
      }
    renewarry();
}*/


/* m = line length; n = number of lines */
/* esta funcion es una pequena variante de la anterior */
/* logra la simetria de una forma no tan elegante */
/* pero corrige el detalle de la segunda generacion dado*/
/* en la rutina anterior */
void shortevolve(m,n) int m, n; {
int i, j, k, l, o,k1;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
        if (j==0) {k=0; l=0; k1=0;}
        if (j==1) {k=0, l=0; k1=1;}
        if (j>1) {k=(j-1)%2;if(k==1) k1=0;else k1=1;l=(j-1)/2;}
        for (i=0; i<m; i++) videodot(5*j,5*i+2*k1,arr1[(AL+i+o-l-k)%AL]);
        onegen(AL);
      }
    renewarry();
}

/* --------------------------- T I M E  -  D A T E-------------------------- */

// #include <stdio.h>
// #include <stdlib.h>
// #include <time.h>

/* 
    Turbo C Reference Guide Version 2.0 (1988)
    Borland International.
    Chapter2, The Turbo C library, pag. 226.
*/

// main(void)
// {
//   struct tm  *timeptr;
//   time_t  secsnow;

/*  timezone = 8*60*60; */
//   time(&secsnow);
//   timeptr = localtime(&secsnow);
//   printf("The data is %d-%d-19%02d\n",
//          ((timeptr->tm_mon) + 1), timeptr->tm_mday,
//           timeptr->tm_year);
//   printf("Local time is %02d:%02d:%02d\n",
//          timeptr->tm_hour, timeptr->tm_min,
//         timeptr->tm_sec);
// }

/* --------------------------- E V O L U T I O N --------------------------- */
      

- plotDot:sender {return self;}

- makeline:sender {int i;
  char *s; double p;
    s=[[sender selectedCell] title];
    printf("Line - %s\n",s);
    switch (s[0]) {
      case 'h':
        printf("random line\n");
        p=0.5;
	ranlin(p);
        printf("%6.3f \n",p);
        break;
      case 'r':
        printf("random line\n");
        p=[pslid floatValue];
	ranlin(p);
        printf("%6.3f \n",p);
        break;
      case 's':
        printf("single cell\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
	    arr1[AL/4]=1;
            arr1[AL/2]=1;
            arr1[(3*AL)/4]=1;
            arr1[(3*AL)/4+2]=1;
/*	    lmenu(); */
        break;
      case 'z':
        printf("zero line\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
/*	    lmenu(); */
	break;
      default: break;}

    drawview=2;
    drawLine=YES;
    [self display];
    drawLine=NO;

return self;
}

- drawShEvol:sender {char ch[40];
//   sprintf(ch,"Rule %12u",wru());
//   [ruleNumber setStringValue: ch];
    drawview=7;
    drawShort=YES;
    [self clear: self];
    [theShEvolView display];
    drawShort=NO;
return self;
}

- printShEvol:sender {char ch[40];
    drawview=7;
    drawShort=YES;
    [self clear: self];
//   sprintf(ch,"Rule %12u",wru());
//   [ruleNumber setStringValue: ch];
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==basinWindow)  [self printBasin:  sender];
    if (keyWindow==shEvolWindow) [self printShEvol: sender];
    if (keyWindow==thEvolWindow) [self printThEvol: sender];
    if (keyWindow==evolWindow)   [self printEvolu:  sender];
    if (keyWindow==probWindow)   [self printBlock:  sender];
    if (keyWindow==plaidWindow)  [self printPlaid:  sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theEvolView getBounds: &zbounds];
  [theEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyProb:sender {
NXRect zbounds;
id     pBoard;
  drawview=9;
  drawBack=NO;
  drawMeanF=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theProbView getBounds: &zbounds];
  [theProbView writePSCodeInside: &zbounds to: pBoard]; 
  drawMeanF=NO;
  drawBack=YES;
return self;
}

- copyLCAU:sender {
    if (keyWindow==basinWindow)  [self copyBasin:  sender];
    if (keyWindow==shEvolWindow) [self copyShEvol: sender];
    if (keyWindow==thEvolWindow) [self copyThEvol: sender];
    if (keyWindow==evolWindow)   [self copyEvolu:  sender];
    if (keyWindow==probWindow)   [self copyProb:   sender];
    if (keyWindow==plaidWindow)  [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
	needsClearing = YES;
return self;
}

- printEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode: self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;

return self;
}

double tdist(i,j,n) int i, j, n; {int a[10], b[10], l, m; double kay, s, t, u;
  if (n>10) return 0.0; 
  kay=1.0/((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[n-l-1]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[n-l-1]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++) {u=a[l]-b[l]; s+=t*((u<0.0)?-u:u);}
  return s*kay;
}




/* -------------------------------- L C A U -------------------------------- */

- setTotalisticState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [self showWrule:self];
    totoasc();
  return self;
  }
 
- showWrule:sender
{char ch[40];

   wru(ch);
   [wrule setStringValue: ch];
	[tiDat setStringValue: "today: now"];

  return self;
  }

// esta funcion se va a dar de baja
//unicamente hay que checar si la direccon del calculo es el correcto
//void wru(c) char *c; {
//char i;
//int  j;
//int  i0, i1;
//j=0;
//for (i0=0; i0<KK; i0++)
//for (i1=0; i1<KK; i1++)
 // {
 // i=4*(ascrule[i0][i1]-'0')+ascrule[i0][i1+1];
 // if (i>'9') i=i+('A'-':');
 // c[j]=i;
 // j++;
 // }
//c[j]=0;
//}


- setRule:sender  {char ch[40];
   wru(ch);
   [wrule setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
   wru(ch);
   [wrule setStringValue: ch];
  return self;
}

- takeWrule:sender {
  [self defineWrule: [sender intValue]];
  return self;
  }

- protectRhule:sender {int c, s;
  s=![sender intValue];
  c=[sender selectedCol];
  [[ascru cellAt:0:c] setEnabled:s];
  [[ascru cellAt:0:c] setBordered:s];
//    [ascru display];
return self;
}



/* -------------------------------- A R D N -------------------------------- */


- printArhi:sender {
    drawview=5;
    drawArhi=YES;
    [keyWindow smartPrintPSCode: self];
    drawArhi=NO;
	needsClearing = YES;
return self;
}

/* -------------------------------- R I J N -------------------------------- */

/* -------------------------------- P R O B -------------------------------- */

- prob:sender {return self;}

- probHowMany:sender {return self;}

- probSetEI:sender {
int i;
  for (i=0; i<6; i++) [[probEI cellAt:i:0] setState: NO];
  for (i=0; i<6; i++) [[probEI cellAt:i:1] setState: NO];
  [[probEI cellAt:5:0] setState: YES];
  [probEI display];

return self;
}

- probSetBlk:sender {
  probBlkV=[[sender selectedCell] title][0];
return self;
}

- probSetGen:sender {
  probGenV=[[sender selectedCell] title][0];
return self;
}


- drawProb:sender {
    drawview=5;
    drawMeanF=YES;
    [self display];
    drawMeanF=NO;
	needsClearing = YES;
return self;
}

- printProb:sender {
   drawview=5;
   drawMeanF=YES;
   [keyWindow printPSCode:self];
   drawMeanF=NO;
return self;
}

- drawEntropy:sender {
    drawview=9;
    drawEntpy=YES;
    [self display];
    drawEntpy=NO;
	needsClearing = YES;
return self;
}

- printEntropy:sender {
   drawview=9;
   drawEntpy=YES;
   [keyWindow printPSCode:self];
   drawEntpy=NO;
return self;
}


- drawBlock:sender {
    drawview=0;
    draw2Block=YES;
    [self display];
    draw2Block=NO;
	needsClearing = YES;
return self;
}

- printBlock:sender {
   drawview=0;
   draw2Block=YES;
   [keyWindow printPSCode:self];
   draw2Block=NO;
return self;
}

- drawNBlock:sender {
    drawview=4;
    drawNBlk=YES;
    [self display];
    drawNBlk=NO;
	needsClearing = YES;
return self;
}

- printNBlock:sender {
   drawview=4;
   drawNBlk=YES;
   [keyWindow smartPrintPSCode:self];
   drawNBlk=NO;
return self;
}

- drawStat:sender {
    drawview=5;
    showStat=YES;
    [self display];
    showStat=NO;
	needsClearing = YES;
return self;
}

- printStat:sender {

   drawview=5;
   showStat=YES;
   [keyWindow smartPrintPSCode:self];
   showStat=NO;
return self;
}

- nxmoncar: (int) l {
int i, j, k, n, b[KK], bb[KK][KK];
double bf[KK], bbf[KK][KK];
double a[KK], aa[KK], d[KK], el, en, t, tt, s;

// nblclr();
n=[[statLines selectedCell] tag];
asctobin();
el=1.0/((double)AL);
en=1.0/((double)n);
for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
for (k=0; k<n; k++) {
  onegen(AL);
  for (i=0; i<KK; i++) b[i]=0;
  for (i=0; i<AL; i++) b[arr1[i]]++;
  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
  for (i=1; i<AL; i++) bb[arr1[i-1]][arr1[i]]++;
  bb[arr1[AL-1]][arr1[0]]++; 
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
    bbf[i][j]=((double)(bb[i][j]))*el;
//  videodot(199-(int)(100.0*bbf[1][1]),BORG+(int)(100.0*bf[1]),l);
  }
for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
s=1.0/log((double)KK);
t=0.0; tt=0.0;
for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
  [statLamb setDoubleValue: 1.0-bf[0]];
  [statEntro setDoubleValue: -t*s];
  [statEnpai setDoubleValue: -0.5*tt*s];
 printf("avera= %5.3f, %5.3f, %5.3f, %5.3f, %5.3f\n",a[0],a[1],a[2],a[3],a[4]);
 printf("devia= %5.3f, %5.3f, %5.3f, %5.3f, %5.3f\n",d[0],d[1],d[2],d[3],d[4]);
	[statSDevi setDoubleValue: (d[0]+d[1]+d[2]+d[4]+d[5])/5.0];
  for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: bf[i]];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
	//[[statPair cellAt: 0: i*KK+j] setDoubleValue: bbf[i][j]];
	[[statPair cellAt: i: j] setDoubleValue: bbf[i][j]];
	[[statProd cellAt: i: j] setDoubleValue: bf[i]*bf[j]];
        }  
return self;
}




/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, i0, i1;
int    stat[KK], stal, stac, star;		/* statistic counts */
double staf[KK], t, pp;

pp=1.0/((double)(KK*KK));
stal=0; stac=0; star=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  j=ascrule[i0][i1]-'0';
  stat[j]++;
  if(j==i0) stal++;
  if(j==i1) star++;
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
// for (i=0; i<KK; i++) printf("%d freq - %5.2f\n",i,staf[i]);
	[statIndx setDoubleValue: ((double)stal)*pp at: 0];
	[statIndx setDoubleValue: ((double)star)*pp at: 1];
// j=199-(int)(100.0*staf[1]);
// i=CORG+(int)(100.0*staf[1]);
// if (j>=2) videodot(j-2,i,l);
// if (i>=2) videodot(j,i-2,l);
// videodot(j,i,1);
// if (i<=318) videodot(j,i+2,l);
// if (j<=198) videodot(j+2,i,l);
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
return self;
}

/* -------------------------------- * * * * -------------------------------- */


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - L C A U V i e w - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	[self setRadius:DEFAULTRADIUS];
	points = [[Storage alloc]
		initCount:0 elementSize:sizeof(NXPoint) description:"{ff}"];
	crossCursor = [NXCursor 
		newFromImage: [NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];
	/* 
	 * Normally, the next two message expressions would be combined, as:
	 * 		readOut = [[Cell alloc] initTextCell:""];
	 * but are here separated for clarity.
	 */
	readOut = [Cell alloc];
	[readOut initTextCell:"pointies"];
	[readOut setBezeled:YES];
	loadPSProcedures();

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

//    videocursor(0,0,0);
//    PSshow("...LCAU21..."); 

  [self setFlipped: YES];

	return self;
}

- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k, l, n;
        double           p, q, s, r, dp, pee, cue;
  struct tm  *timeptr;
  time_t  secsnow;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* 
	 * If we're printing, we need to load drawing procedures to the 
	 * printing context. This simple test is OK for a View that prints a 
	 * single page.  If there were multiple pages, the procedures would be 
	 * loaded multiple times.  Although this is inefficient, it causes no 
	 * error.  Views that print multiple pages should load procedures such 
	 * as these in an endPrologue method (see the View spec sheet). 
	 */
	if (NXDrawingStatus != NX_DRAWING) 
		loadPSProcedures();

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);


        if (drawEvol==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
	  if ([keepTop state]) savearry();
	  evolve();
	  if ([keepTop state]) renewarry();
	  }

          if (drawShort==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

        if (drawThird==YES) {
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/10.0);
	  j=(int)(plotRect.size.height/10.0);
	  shortevolve(i,j);
	  }

if (drawPlaid==YES) {		/* one cycle of evolution */
	  n=[[gridSize selectedCell] tag];
	  if (strcmp([[aSwitch selectedCell] title],"distance")==0) {
	    [ruleNumber setStringValue: "distance matrix"];
	    for (i=0; i<243; i++) for (j=0; j<243; j++) {
	      r=tdist(i,j,5);
	      PSsetcmykcolor(0.1*r,0.8*r,1.0-r,0.55*r);
	      PSrectfill((float)(j),(float)(i),1.0,1.0);
	      }
	    PSstroke();
	    }
	  if (strcmp([[aSwitch selectedCell] title],"circles")==0) {
	    needsClearing = YES;
	    [points empty];
	    sprintf(c,"center: %3d, %3d\n",plaidline[0],plaidline[1]);
	    [ruleNumber setStringValue: c];
	    for (i=0; i<243; i++) for (j=0; j<243; j++) {
	      p=tdist(i,plaidline[1],5);
	      q=tdist(j,plaidline[0],5);
	      s=(p+q);
	      PSsetcmykcolor(s,0.05*p,1.0-s,0.05*q);
	      PSrectfill((float)(j),(float)(i),1.0,1.0);
	      }
	    PSstroke();
	    PSsetgray(NX_BLACK); 
	    PSrectfill((float)(plaidline[0]),(float)(plaidline[1]),2.0,2.0);
	    PSstroke();
	    }
	  if (strcmp([[aSwitch selectedCell] title],"plaid")==0) {
	    wru(c);
	    [ruleNumber setStringValue: c];
	    savearry();
	    asctobin();
	    for (j=0; j<128; j++) {
	      ranlin();
	      for (i=0; i<64; i++) {onegen(AL); pprob();}
	      }
	    renewarry();
	  }
	if (n>0) {
	  PSsetgray(NX_BLACK); 
	  PSsetlinewidth(0.0);
	  for (j=1, dp=243.0, i=0; i<n; i++) {j*=3; dp*=0.333;}
	  for (i=0, p=1.0; i<j+1; i++, p+=dp) {
	    PSmoveto(0.1,p);
	    PSlineto(243.0,p);
	    PSmoveto(p,0.1);
	    PSlineto(p,243.0);
	    }
	  PSstroke();
	  }
	}

	





        if (drawMeanF==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
	if ([[probEI cellAt:5:0] state]) lifreq(100,0,0,2);
	if ([[probEI cellAt:4:0] state]) pdiff(100,6);
	if ([[probEI cellAt:3:0] state]) pddiff(100,6);
	if ([[probEI cellAt:2:0] state]) ptdiff(100,6);
	if ([[probEI cellAt:1:0] state]) pfdiff(100,6);
	if ([[probEI cellAt:0:0] state]) pvdiff(100,6);

	if ([[probEI cellAt:4:1] state]) pidiff(100,6,1);
	if ([[probEI cellAt:3:1] state]) pidiff(100,6,2);
	if ([[probEI cellAt:2:1] state]) pidiff(100,6,3);
	if ([[probEI cellAt:1:1] state]) pidiff(100,6,4);
	if ([[probEI cellAt:0:1] state]) pidiff(100,6,5);

	if ([probGrid state]) {
	     PSsetlinewidth(0.0);
	     PSsetgray(NX_BLACK);
	     linegrid(10);
	     PSstroke();
	     }

//	  for (i=0; i<6; i++) if ([[probEI cellAt:i:0] state]) procur('e',5-i);
//	  for (i=0; i<6; i++) if ([[probEI cellAt:i:1] state]) procur('i',5-i);
		}

if (drawEntpy==YES) {
//	     penry(100);
	     PSsetlinewidth(0.05);
	     PSsetgray(NX_BLACK);
	     linegrid(10);
	     PSstroke();
	     PSsetlinewidth(0.0);
           }



	if (draw2Block==YES) {
   wru(c);
   [ruleNumber setStringValue: c];

   time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(c,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);
   [tiDat setStringValue: c];

   if (strcmp([[probEI selectedCell] title],"Compose")==0) {
    if ([[probComp cellAt: 0: 0] state]) cudem(cubic,25,25,25,6);
    if ([[probComp cellAt: 1: 0] state]) cudem(cubic,25,25,25,7);
    if ([[probComp cellAt: 2: 0] state]) cudem(cubic,25,25,25,8);
	}
   if (strcmp([[probEI selectedCell] title],"Iterate")==0) {
    if ([[probComp cellAt: 0: 0] state]) cudem(cubic,25,25,25,11);
    if ([[probComp cellAt: 1: 0] state]) cudem(cubic,25,25,25,10);
    if ([[probComp cellAt: 2: 0] state]) cudem(cubic,25,25,25,9);
	}

    p=[pslid doubleValue];
    l=0;
    if (strcmp([[probView selectedCell] title],"front")==0) l=0;
    if (strcmp([[probView selectedCell] title],"plan")==0) l=1;
    if (strcmp([[probView selectedCell] title],"side")==0) l=2;

    if ([[probLevel cellAt: 2: 0] state]) {
		PSsetlinewidth(0.1);
	  PSsetgray(NX_BLACK);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,p,i,j,k,l);
	}
		PSstroke();
      }

    if ([[probLevel cellAt: 1: 0] state]) {
	  PSsetlinewidth(0.0);
	  PSsetcmykcolor(0.0,1.0,0.2,0.0);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,2.0*p,i,j,k,l);
	}
		PSstroke();
     }

    if ([[probLevel cellAt: 0: 0] state]) {
	  PSsetlinewidth(0.0);
	  PSsetcmykcolor(1.0,0.0,0.2,0.0);
    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
      conth(cubic,3.0*p,i,j,k,l);
	}
		PSstroke();
      }

//	  PSsetgray(NX_LTGRAY);
	  PSsetgray(NX_BLACK);
    confr(l);
		PSstroke();
            }

	if (drawNBlk==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
	  nblcur(probBlkV);
	  for (i=0; i<KK; i++) [[haHa cellAt: 0: i] setDoubleValue: blpr[i]];
	  }

	if (showStat==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
	 /* if (strcmp([[statMode selectedCell] title],"static")==0) [self nxasfreq];
	  if (strcmp([[statMode selectedCell] title],"dynamic")==0) { */
	    if (strcmp([[statNhood selectedCell] title],"totalistic")==0) {
		[self nxmoncar: 2];
		neisum(0,AL,48);
                }
	    if (strcmp([[statNhood selectedCell] title],"general")==0) {
		[self nxmoncar: 2];
		gnlsum(0,AL,48);
                }
	   // }
	  }


        if (drawArhi==YES) {
      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
      stt=0.0;
      allmo(&stt,sta);
      ss=1;
		}

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}


/*   PSsetgray(NX_BLACK); */
/*   PSselectfont("Times-Roman",16.0); */

/*   PSmoveto(250.0,388.0); */
/*   PSselectfont("Times-Roman",16.0); */
/*   PSshow("LCAU21"); */



	/* now take each point and draw it */
	PSsetgray(NX_BLACK);
	i = [points count];
	while (i--) {
		aPoint = (NXPoint *)[points elementAt:i];
		drawCircle(aPoint->x, aPoint->y, radius);
	} 
	return self;
}

- clear:sender
/*
 * Clears the LCAUView by emptying its Storage object of all points
 * and then redisplaying the LCAUView.  This action is taken only if
 * the LCAUView's state requires it.
 */
{
	if (needsClearing) {
		[points empty];
		[self display];
		needsClearing = NO;
	}
	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	else 
		[self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- registerPoint:(NXPoint *)aPoint
/*
 * Adds a point to the list the LCAUView keeps in its Storage object. 
 */
{
	[points addElement:aPoint];
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;
   	char	buffer[100];

         double  x, y, ex, wy, eks, wye;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {snod=k;} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	 /* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && 
		[delegate respondsTo:@selector(PlotView:pointDidChange:)])
		[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && 
	(theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- setRadius:(float)aFloat
/*
 * Sets the value for the radius of the LCAUView's points.
 */
{
	radius = aFloat;
	return self;
}


- (float)radius
/*
 * Returns the value for the radius of the LCAUView's points.
 */
{
	return radius;
}


- read:(NXTypedStream *)stream
/*
 * Unarchives the LCAUView.  Initializes four of the LCAUView's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	delegate = NXReadObject(stream);
	NXReadTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LCAUView by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	NXWriteObjectReference(stream, delegate);
	NXWriteTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- awake
/*
 * Finishes initializing a LCAUView that has just been unarchived (see the 
 * read: method).
 */
{
	loadPSProcedures();
	return [super awake];
}


- (const char *)inspectorName
{
    return "LCAUViewInspector";
}

- plot:sender
/*
 * Responds to a plot: message by asking the LCAUView's delegate for a stream
 * containing the points to plot.  It then extracts number pairs from the 
 * stream and creates NXPoint structures with them.  For each structure it 
 * creates, the LCAUView sends itself a registerPoint: message to add the 
 * point to its list of points.  This simple parser ignores input it doesn't 
 * understand.
 */
{
	int	 	 c, sign, retval;
	float	 	 aNum;
	NXPoint	 	 aPoint;
	NXStream	*stream;
	BOOL		 processedLine = NO, gotFirst = NO, gotSecond = NO;
	
	if (delegate && [delegate respondsTo:@selector(PlotView:providePoints:)])
		[delegate PlotView:self providePoints:&stream];
	NXSeek(stream, 0, NX_FROMSTART);
	while ((c = NXGetc(stream)) != EOF){
		sign = 1;
		retval = getSeparator(stream);
		if (retval == 1) {
			c = NXGetc(stream);
		} else if (retval == -1) {
			break;
		}
		if (!NXIsDigit(c)) {
			if ((c == '-') && NXIsDigit(c = NXGetc(stream))){
					sign = -1;
			} else {
				while( (c != '\n') && (c != EOF)) {
					c = NXGetc(stream);
					processedLine = YES;
				}
			}
		}
		if (c == EOF)
			break;
		else if (processedLine) {
			processedLine = NO;
			continue;
		}
		aNum = getNumber(stream);
		if (!gotFirst) {
			aPoint.x = sign * aNum;
			gotFirst = YES;
		} else if (!gotSecond) {
			aPoint.y = sign * aNum;
			[self registerPoint:&aPoint];
			gotFirst = gotSecond = NO;
		} 
	}
	[self display];
	needsClearing = YES;
	return self;
}

int getSeparator(NXStream *stream)
/* 
 * Removes white space, commas, and plus signs from between 
 * number pairs.
 */
{
	int c, firstChar;
	
	NXUngetc(stream);
	c = firstChar = NXGetc(stream);
	while (NXIsSpace(c) || (c == ',') || (c == '+'))
		c = NXGetc(stream);
	/* 1 = ate something; 0 = ate nothing; -1 means EOF */
	if (c == firstChar)
		return 0;
	else if (c == EOF)
		return -1;
	NXUngetc(stream);
	return 1;
}

float getNumber(NXStream *stream)
/* 
 * Composes a floating point number from a string of number  
 * characters.
 */
{
	int c, i = 0;
	char temp[MAXNUMLENGTH];
	
	NXUngetc(stream);
	c = NXGetc(stream);
	while ((NXIsDigit(c) || (c == '.')) && (c != '\n') && (c != EOF)) {
		temp[i++] = c;
		c = NXGetc(stream);
	}
	NXUngetc(stream);
	temp[i] = 0;
	return (atof(temp));
}

@end

/* end LCAUView.m */
