
/* 
 * OverAll.m -- Implementation file for the OverAll class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import "OverAll.h"
#import "nxlcau9h.h"
#import "rec.h"
#import <math.h> 
#import <stdlib.h>
#import <string.h>
#import <time.h>

NXColor colst[KK];

NXDefaultsVector defaults={
  {"well0","1.0,0.0,0.0"},
  {"well1","0.0,1.0,0.0"},
  {"well2","0.0,0.0,1.0"},
  {"well3","0.5,0.0,0.5"},
  {"well4","0.5,0.5,0.3"},
  {"well5","0.6,0.4,0.2"},
  {"well6","0.5,0.1,0.4"},
  {"well7","0.2,0.1,0.4"},
  {"well8","0.1,0.6,0.4"},
  {NULL,NULL}
  };

 char colorwells[KK][6]={
	"well0",
	"well1",
	"well2",
	"well3",
	"well4",
	"well5",
	"well6",
	"well7",
	"well8"
	};
  
extern struct fptbl dtbl[];
extern Inst xprg[XLEN];
extern char idef[][30];

void rule9h();

@implementation OverAll

/* ---------------  A P P   I N I T I A L I Z A T I O N   ----------------- */

- appWillInit:sender {printf("appWillInit\n"); return self;}

- appDidInit:sender {
char c[WNML];           /* nombre de la regla trece digitos + control de fin */
struct tm  *timeptr;    /* apuntador de la hora */
time_t  secsnow; 
char *df;
double red,green,blue;       
int i;

  printf("appDidInit = nxlcau9h\n");
  rule9h();     /* printf("rule9h\n"); */
  asctobin();   /* pasa la regla dada de ascii a binario */      
  ttzero();     /* inicializa la regla totalistica a cero */
//  gfzero();
  [rulePanel setAllRules: self];

 NXRegisterDefaults("NXLCAU9HDefaults",defaults);
      NXUpdateDefaults();
      for (i=0; i<KK; i++){
       df=NXGetDefaultValue("NXLCAU9HDefaults",colorwells[i]);
       sscanf(df,"%6lf,%6lf,%6lf",&red,&green,&blue); 
       colst[i]=NXConvertRGBToColor(red,green,blue);
       printf("%s: %s\n",colorwells[i],df);
       }

      [[NXColorPanel sharedInstance:YES]setContinuous: YES];

 [browser getTitleFromPreviousColumn: YES];
 [browser setDoubleAction: @selector(copyAndRunREC:)];
 [browser setPath: "/demonstrations"];

  /* initialize r_vst with selected standard procedures */ 
       rec_c(idef[0],xprg[0],128,dtbl);
       r_vst['a']=xprg[0];

      printf("end appDidInit\n");
return self;
}

- appWillTerminate:sender {return self;}

- awakeFromNib {printf("awaking from nib\n"); return self;}

/*--------------------------G E N E R A L ---------------------------------*/

- revertColors:sender
{char c[32], *df; int i; double red, green, blue;
  for (i=0; i<KK; i++) {
      sprintf(c,"%6.3f, %6.3f, %6.3f",
              NXRedComponent(colst[i]),
              NXGreenComponent(colst[i]),
              NXBlueComponent(colst[i])
              );
      NXWriteDefault("NXLCAU9HDefaults",colorwells[i],c);
              };
   for (i=0; i<KK; i++){
       df=NXGetDefaultValue("NXLCAU9HDefaults",colorwells[i]);
       sscanf(df,"%6lf,%6lf,%6lf",&red,&green,&blue); 
       colst[i]=NXConvertRGBToColor(red,green,blue);
       printf("%s: %s\n",colorwells[i],df);
       }
 return self;
}

- saveColors:sender
{char c[32]; int i;
  for (i=0; i<KK; i++) {
      sprintf(c,"%6.3f, %6.3f, %6.3f",
              NXRedComponent(colst[i]),
              NXGreenComponent(colst[i]),
              NXBlueComponent(colst[i])
              );
      NXWriteDefault("NXLCAU9HDefaults",colorwells[i],c);
              };
 return self;
}

- updateColors {
printf("updateColors\n");
	[inCol0 setColor: colst[0]];
	[inCol1 setColor: colst[1]];
	[inCol2 setColor: colst[2]];
	[inCol3 setColor: colst[3]];
	[inCol4 setColor: colst[4]];
	[inCol5 setColor: colst[5]];
	[inCol6 setColor: colst[6]];
	[inCol7 setColor: colst[7]];
	[inCol8 setColor: colst[8]];
return self;
}

- windowDidBecomeKey:sender {
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyWells:)];
	[menuCopy setEnabled: YES];
return self;
}

- windowDidResignKey:sender {[menuCopy setEnabled: NO]; return self;}

- copyWells:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theWellBox getBounds: &zbounds];
  [theWellBox writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - -  R E C   L I N E   C O N F I G U R A T I O N  - - - - - */
 
- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
 return self;
}

- runRECLine:sender {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [rulePanel setAllRules: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}


@end
