
#import "RulePanel.h"
#import "nxlcau9h.h"
#import <string.h>
#import <math.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern birular binrule;
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];
extern char gf9rule[];		/* coefficients of GF9 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK][SS];
extern char sarule[KK][SS];

/* declaraciones de GrabBag */

extern  struct  fptbl  dtbl[];
extern  Inst    xprg[][XLEN];
extern  char	idef[][30];

int longwolftoasc(char *c);

int permu[RSYM/2][KK] = {
	{0, 1, 2, 3},
	{1, 2, 3, 0},
	{2, 3, 0, 1},
	{3, 0, 1, 2},

	{1, 2, 0, 3},
	{2, 3, 1, 0},
	{3, 0, 2, 1},
	{0, 1, 3, 2},

	{2, 0, 1, 3},
	{3, 1, 2, 0},
	{0, 2, 3, 1},
	{1, 3, 0, 2},


	{1, 0, 2, 3},
	{2, 1, 3, 0},
	{3, 2, 0, 1},
	{0, 3, 1, 2},

	{2, 1, 0, 3},
	{3, 2, 1, 0},
	{0, 3, 2, 1},
	{1, 0, 3, 2},

	{0, 2, 1, 3},
	{1, 3, 2, 0},
	{2, 0, 3, 1},
	{3, 1, 0, 2}
	};


/* ........................*/

int     allperm(char wnum[][WNML], char ii[][KK][KK], char ru[KK][KK]);
void    asctobin();
void    asctotot();
void	asczero();
void	auxzero();
void    bincopy(birular *rz, birular *rx); 
void    binprint(birular *rz);
void    binprod(birular *rz, birular *rx, birular *ry);  
void    binsum(birular *rz, birular *rx, birular *ry);
void    bintoasc();
void    chrucopy(char ii[KK][KK], char jj[KK][KK], int c);
void    clumin(char *c);
int     cyy(int i);
int     czz(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
int     longwolftoasc(char *c);
void    nutowo1(int i);
void    nutowo2(int i);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of4(int a, int b);
int     ran3of4(int a, int b, int c);
void    ranrul();
void    ranblin(double p0, double p1, double p2,
		double p3, double p4, double p5,
		double p6, double p7, double p8);
void    ranvachrul(char *c);
void    rule4h();
void    runowows(char x[2][2], int n);
void	sttoasc();
void    stzero();
int     svwolftoasc(char arul[KK][KK], char *c);
void	totoasc();
int     totonu(int i);
void    ttzero();
int     vecperm(int ii[KK], int n);
int     wolbin(int i, int j);
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK]);
void    wrrub3h(char *c, int ru[3][3]);
int     wrub3h(int ru[3][3]);
void	xtoasc(int n);
int     ycc(int i);
int     zcc(int i);

char    xr[DS] = "1212201012212000001010001";
char    xp[DS] = "5323372423353614112526112";
char    xq[DS] = "1464476764474257556767556";

int  goodCart = NO;
int  frul[2][3][3];

@implementation RulePanel


/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
  if (strcmp(ch,"lcaukr")==0)      [self loadLowerPanel: lcauRuleBox];
  if (strcmp(ch,"permuted")==0)    [self loadLowerPanel: pmutRuleBox];
  if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"clannish")==0)    [self loadLowerPanel: subsetRuleBox];
  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
 id cv;
cv=[thisRuleBox contentView];
printf("thisRuleBox subviews = %d\n",[[cv subviews] count]);
  nowSpesh=thisRuleBox;
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- protectGenRule:sender
{int i, j, k, i0, i1,l,m;
  printf("estoy en -protecGenRule\n");
  i=j=[sender selectedCol];
  printf("columna seleccionada i=%d  j=%d:\n",i,j);
  i1=i%KK; i/=KK;
  printf(" i1=%d  i=%d:\n",i1,i);
  i0=i%KK; i/=KK;
  printf("i0=%d  i=%d:",i0,i);
  for (l=0; l<KK; l++) for (m=0; m<KK; m++) printf("auxrule[%d][%d]=%d\n",l,m,auxrule[l][m]);
  k=auxrule[i0][i1];
  printf("k=auxrule[%d][%d]=%d\n",i0,i1,auxrule[i0][i1]);
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1]=!k;
  printf("auxrule[%d][%d]=%d=!k\n",i0,i1,auxrule[i0][i1]);
  printf("fin de -protecGenRule\n");
return self;
}

- relatedRule:sender
{
char    ii[240][KK][KK], wnum[240][WNML], *titl;
int     j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"reflected")==0) {k=120;}
  else if (strcmp(titl,"flip")==0)      {k=60;}
  else if (strcmp(titl,"cycle  5")==0)  {k=1;}
  else if (strcmp(titl,"cycle  4")==0)  {k=5;} 
  else if (strcmp(titl,"cycle  3")==0)  {k=20;} 
  else if (strcmp(titl,"cycle  2")==0)  {k=60;} 
  else if (strcmp(titl,"least")==0)     {k=l;}
  else    k=0;
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  if ([changeLine state]) {
    l=vecperm(jj,k);
    for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
    if (l) {
      for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
      for (j=0; j<AL; j++) arr1[j]=arr2[j];
      }
    }
// printf ("related rules\n");
// for (k=0; k<12; k++) printf("%s\n",wnum[k]);
return self;
}

/*  generate a table of permutations of a given rule      */
/*  and report the index of the rule with smallest wru    */
/*  wn - array to be filled with 13-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images  */
/*  ru - reference KK8KK table - e.g. ascrule          */
/*  return value is the index of the least of all these   */
/*  that is, wn[...] is the number, ii[...] is the rule   */
int allperm(wn,ii,ru) char wn[][WNML], ii[][KK][KK], ru[KK][KK]; {
int k, l,j,i,n;
   chrucopy(ii[  0], ru, 'w');		 /* (0 1 2 3 4) identity */
 /* cyclic permutation n (0 1 2 3 4) */
   for (i=1; i<5; i++) chrucopy(ii[i],ii[i-1], 'y');
 /* cyclic permutation n-1 (1 2 3 4)*/
   j=0; for (i=5; i<20; i++){n=j/3;
chrucopy(ii[i], ii[n%3], 'x'); j++;}
 /* cyclic permutation n-2 (2 3 4)*/
   j=0;
for (i=20; i<60; i++){n=j/2; chrucopy(ii[i], ii[n%2], 'v'); j++;}
/* cyclic permutation n-3 (transpose) (3 4) (2 3).. */
   for (i=0; i<60; i++) chrucopy(ii[i+60],ii[i], 't');
/* Reflexion */
/* (0 1 2 3 4) identity */
   chrucopy(ii[120], ru, 'r');
/* cyclic permutation n (0 1 2 3 4)*/
   for (i=120; i<125; i++) chrucopy(ii[i+1],ii[i-120], 'r');
/* cyclic permutation n-1 (1 2 3 4)*/
   j=0; for (i=125; i<140; i++){n=j/3; chrucopy(ii[i], ii[n%3], 'r'); j++;}
/* cyclic permutation n-2 (2 3 4)*/
   j=0;
for (i=140; i<180; i++){ n=j/2; chrucopy(ii[i], ii[n%2], 'r'); j++;}
/* cyclic permutation n-3 (transpose) (3 4) (2 3).. */
   for (i=180; i<240; i++) chrucopy(ii[i],ii[i-180], 'r');

    for (k=0, l=0; k<240; k++) {
    wrru(wn[k],ii[k]);
    if (strlen(wn[k]) > strlen(wn[l])) continue;
    if (strlen(wn[k]) < strlen(wn[l])) {l=k; continue;}
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
  return l;
}


/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */

int vecperm(ii,n) int ii[KK], n; {int i, k, l;
  l=!(n<RSYM/2); k=(l?n-(RSYM/2):n);
   for (i=0; i<KK; i++) ii[i]=permu[k][i];
  return l;
}


/* copy a related (character) rule */
/* c = w - no change               */
/* c = y - cyclic permutation      */
/* c = r - reflected               */
/* c = t - transpose            */

void chrucopy(ii,jj,c) char ii[KK][KK], jj[KK][KK], c; {
int i0, i1;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=jj[i0][i1];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=ycc(jj[cyy(i0)][cyy(i1)]);
      break;
    case 'x':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=xcc(jj[cxx(i0)][cxx(i1)]);
      break;
    case 'v':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=vcc(jj[cvv(i0)][cvv(i1)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
     	ii[i0][i1]=jj[i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      	ii[i0][i1]=fli(jj[fli(i0)][fli(i1)]);
      break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
        case '1': return '1';
        case '2': return '2';
	case '3': return '4'; 
	case '4': return '3';
        case  0 : return  0 ;
        case  1 : return  1 ;
        case  2 : return  2 ;
	case  3 : return  4 ; 
	case  4 : return  3 ;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '4';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 4;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cxx(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '1';
	case 0: return 0;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 1;
	default:  return '0';}
}

int xcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '4'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 4; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cvv(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '2';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 2;
	default:  return '0';}
}

int vcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '4';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 4;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}


/* create the rule defined by the "symmetric rule" panel */
/* - symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, j0, j1, r;

j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    j0=KK+i1-i0;
    j1=KK+i2-i1;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=i2; break;
      case 3: r+=(KK-i0)+(KK-i1); break;
      case 4: r+=(KK-i1)+(KK-i2); break;
      case 5: r+=(KK-i2)+(KK-i0); break;
      case 6: break;
      default: break;}
    ascrule[i2][i1]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  } */

- readWRule:sender
  {char  *c; int l;
     c=[sender stringValue];
     l=strlen(c);
     if(l>WNML-1) {[ruleNumber setStringValue: "too big"]; return self;}
     if (longwolftoasc(c)) [self setAllRules: self];
        else [ruleNumber setStringValue: "invalid"];
     return self;
   }

int longwolftoasc(char *c){
char d[WNML], e;
int i, l, n, i0, i1;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i=0, i0=0, i1=0; i<WNML-1; i++) {
    n=d[WNML-2-i];
    ascrule[i0][i1]='0'+n%KK;
    i1++; if (i1>=KK) {i1=0; i0++; if (i0>=KK) return TRUE;}
    }
  return TRUE;
} 

/* beware - when an error is detected, part */
/* of ascrule may already have been changed */
- setRule:sender 
{int i, j, k, l;
  l=YES;
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
    k=[[sender cellAt: i: j] intValue];
    if (0<=k && k<KK) ascrule[i][j]=k+'0';
      else {l=NO; [[sender cellAt: i: j] setStringValue: "*"];}
    }
  if (l) [self setAllRules: self];
return self;
}

- insertRule:sender {
char c[2];
int  i, j, k;
  i=[sender selectedRow];
  j=[sender selectedCol];
  k=[whichState selectedRow]+'0';
  ascrule[i][j]=k;
  c[0]=k; c[1]=0;
  [[sender selectedCell] setTitle: c];
  [self setAllRules: self];
return self;
}

- setAllRules:sender 
{char ch[WNML]; int i, j;
  wru(ch);
  [ruleNumber setStringValue: ch];
  asctobin();
  for (i=0; i<KK; i++) for (j=0; j<KK; j++)  {
    [[ascru cellAt: i: j] setIntValue: ascrule[i][j]-'0'];
//    if (auxrule[i][j]) [[ascru cellAt: i: j] setEnabled: NO];
//    if (auxrule[i][j]) [[ascru cellAt: i: j] setBordered: NO];
    }
  wru(ch);
  [ruleNumber setStringValue: ch];
//   [self nxasfreq];
   if      (istot()==1) {asctotot(); [self setTotRules: self];}
      else [totlRef setStringValue: " "];
  [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* for 9-state automata, just run off the states  */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument rule */
void wrru(c, ru) char *c, ru[KK][KK]; {
int  j, k, l;
j=0; k=0; l=0;
while (TRUE) {
  c[WNML-1-l-1]=ru[j][k];
  k++; if (k>=KK) {k=0; j++;} if (j>=KK) break;
  l++;
  }
c[WNML-1]=0; 
}

/* generate a random rule */
void granrule() {int i, i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++){
  i=(random()&0xFF)%KK;
  ascrule[i0][i1]=i+'0';
//  printf("%d",i);
  }
//  printf("\n");
}

/* generate a random protected rule */
void granprule() {int i0, i1,i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1]==0) ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}


- randomLine:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

- uniformLine:sender
{ranblin(0.11,0.11,0.11,0.11,0.11,0.11,0.11,0.11,0.12); return self;}


/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[WNML];
   wru(ch);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  printf("fin de -setDemo\n");
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmuteRule: sender {
  asctobin();
  ptedbrul(&binrule,&binrule,[pRu intValue]);
  [self setAllRules:self];
return self;
}

/* - - - - - - - - -    C A R T E S I A N   P R O D U C T    - - - - - - - - */

- prodRule:sender {int i0, i1, i2, i3;
	    for (i0=0; i0<3; i0++)
	    for (i1=0; i1<3; i1++)
	    for (i2=0; i2<3; i2++)
	    for (i3=0; i3<3; i3++)
	    ascrule[3*i0+i1][3*i2+i3]=
		'0'+3*frul[0][i0][i2]+frul[1][i1][i3];
  	    [self setAllRules:self];
printf("prodRule\n");
return self;
}

- cartxRule:sender {int i, j, k;
  for (i=0; i<3; i++) for (j=0; j<3; j++) 
    {k=frul[0][i][j]; frul[0][i][j]=frul[1][i][j]; frul[1][i][j]=k;}
  [self setCartUp: self];
return self;
};

/* change decimal number to binary Wolfram rule number */
void nutowo3h(x,h,ru) int x, h, ru[][3][3]; {
int i, j;
  for (i=0; i<3; i++) for (j=0; j<3; j++) {
    ru[h][i][j]=x%3;
    x/=3;}
    }

- rand3h:sender {int h;
  h=[sender selectedRow];
  nutowo3h(random()%19683,h,frul);
  [self setCartUp: self];
return self;
}

- read3hRule:sender {int h, i, j, k;
  goodCart=NO;
  h=[sender selectedRow];
  k=[[sender selectedCell] intValue];
  if (k>=0 && k<19683) goodCart=YES;
  if (goodCart) {nutowo3h(k,h,frul); [self setCartUp: self];}
  else [[sender selectedCell] setStringValue: "***"];
return self;
}

- read3HRule:sender {int h; char *c;
 h=[sender selectedRow];
 c=[sender stringValue];
 if (svwolftoasc(frul[h],c)) [self setCartUp: self];
 else [[sender selectedCell] setStringValue: "***"];
return self;
}

- readLeftFact:sender {int i, j, k, l, m;
  m=YES;
  for (i=0; i<3; i++) for (j=0; j<3; j++) {
    k=[[sender cellAt: i: j] intValue];
    l=(k>=0 && k<3);
    if (l) frul[0][i][j]=k;
           else {m=NO; [[sender cellAt: i: j] setStringValue: "*"];}
    }
  goodCart=m;
  if (m) [self setCartUp: self];
return self;
}

- readRightFact:sender {int i, j, k, l, m;
  m=YES;
  for (i=0; i<3; i++) for (j=0; j<3; j++) {
    k=[[sender cellAt: i: j] intValue];
    l=(k>=0 && k<3);
    if (l) frul[1][i][j]=k;
           else {m=NO; [[sender cellAt: i: j] setStringValue: "*"];}
    }
  goodCart=m;
  if (m) [self setCartUp: self];
return self;
}

- setCartUp:sender {
char c[6];
int  i, j;
  for (i=0; i<2; i++) {
    wrrub3h(c,frul[i]);
    [[the3hRule cellAt: i: 0] setIntValue: wrub3h(frul[i])];
    [[the3HRule cellAt: i: 0] setStringValue: c];
    }
  for (i=0; i<3; i++) for (j=0; j<3; j++) {
    [[leftFact cellAt: i: j] setIntValue: frul[0][i][j]];
    [[rightFact cellAt: i: j] setIntValue: frul[1][i][j]];
    }
return self;
}

/* use a septavigentesimal number to fill arul */
int  svwolftoasc(char arul[KK][KK], char *c) {
char d[3], e;
int  i, l, n, i0;
  l=strlen(c);
  for (i=0; i<3; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'q') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'Q') n=e-'A'+10;
    else    return FALSE;
    d[3-l+i]=n;
    }
  for (i0=0; i0<3; i0++) {
    n=d[3-i0-1];
    arul[i0][0]='0'+n%3; n/=3;
    arul[i0][1]='0'+n%3; n/=3;
    arul[i0][2]='0'+n%3;
    }
  return TRUE;
}

/* calculate (3,1/2) wru from an argument rule  */
/* beware --- ru is binary, not ASCII		*/
/* the result in c is septavigentesimal 	*/
void wrrub3h(c,ru) char *c; int ru[3][3]; {
int  i;
int  i0;
for (i0=0; i0<3; i0++)
  {
  i= 9*(ru[i0][2])
    +3*(ru[i0][1])
    +  (ru[i0][0])
    +'0';
  if (i>'9') i=i+('A'-':');
  c[3-i0-1]=i;
  }
c[3]=0;
}

int wrub3h(ru) int ru[3][3]; {
int i, j, r;
  r=0;
  for (i=0; i<3; i++) for (j=0; j<3; j++) r=r*3+ru[2-i][2-j];
  return r;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender 
{int i, j, p[KK], ru[KK][KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  p[4]=[pMut4 selectedCol];
  p[5]=[pMut5 selectedCol];
  p[6]=[pMut6 selectedCol];
  p[7]=[pMut7 selectedCol];
  p[8]=[pMut8 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ru[i][j] = ascrule[p[i]][p[j]]-'0';
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ascrule[i][j] = p[ru[i][j]]+'0';
  asctobin();
  [self setAllRules:self];
return self;
}

- pmutValue: sender {int i, j, k, p[KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  p[4]=[pMut4 selectedCol];
  p[5]=[pMut5 selectedCol];
  p[6]=[pMut6 selectedCol];
  p[7]=[pMut7 selectedCol];
  p[8]=[pMut8 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
    k = ascrule[i][j] - '0';
    ascrule[i][j] = p[k] + '0';
    }
  asctobin();
  [self setAllRules:self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - - - - - - - -   G F ( 9 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
//     gf9rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
 //    gf9rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
//     gf9rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF9Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf9rule[i]); printf("\n");
//    gftoasc();
//    [self setAllRules:self];
//    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toWindow setDocEdited:NO];
return self;
}

- readTRule:sender
  {char  *c; int i, j, l, m;
     c=[sender stringValue];
     l=strlen(c); m=YES;
     if(l>TS) {[toRuleNumber setStringValue: "too long"]; return self;}
     for (j=0; j<TS; j++) ttrule[j]='0';
     for (j=0; j<l;  j++) {
       i=c[j];
       if ( i<'0' || i>'8' ) {c[j]='*'; m=NO;}
       }
     if (m) for (j=0; j<l; j++) ttrule[j]=c[j];
       else {[sender display]; return self;}
     totoasc();
     [self setTotRules: self];
     return self;
   }

/* copy ttrule */
void wtrru(c, ru) char *c, ru[TS]; {int  i;
  for (i=0; i<TS; i++) c[i]=ru[i];
  c[TS]=0;
}

- setTotRule:sender {char ch[WNML];
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toWindow setDocEdited:YES];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  if (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
  else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranTRule:sender {char ch[TS+1]; int i, j, k;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setIntValue: NO];
    k=random()%KK;
    ttrule[j]=k+'0';
    [[toascru cellAt: k: j] setIntValue: YES];
    }
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toRuleNumber selectText: self];
  [toWindow setDocEdited:YES];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++) {
          if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1]==0) 
		  ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophobic:sender {int i, j;
  for (i=0; i<KK; i++) ascrule[i][i]=i+'0';
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) 
    switch ([[clanMatrix cellAt: i: j] title][0]) {
    case '0': ascrule[i][j]=i+'0'; ascrule[j][i]=i+'0'; break;
    case '1': ascrule[i][j]=j+'0'; ascrule[j][i]=i+'0'; break;
    case '2': ascrule[i][j]=i+'0'; ascrule[j][i]=j+'0'; break;
    case '3': ascrule[i][j]=j+'0'; ascrule[j][i]=j+'0'; break;
    default: break;}
  [self setAllRules: self];
return self;
}

- enterPair:sender {char c[2]; 
  c[0] = [clan2h selectedRow]+'0'; c[1]=0;
  [[sender selectedCell] setTitle: c];
return self;
}

- randphobic:sender {char c[2]; int i, j;
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) {
    c[0] = (random()%4)+'0'; c[1]=0;
    [[clanMatrix cellAt: i: j] setTitle: c];
    }
return self;
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender 
{int k, n, i0, i1, i2;
    printf("estoy en --seZign\n");
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
    printf("fin de -seZign\n");
return self;
}

- clearDesign:sender {
id  z;
int i;
  printf("estoy en -clearDesign\n");
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
printf("fin de -clearDesign\n");
 return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  printf("estoy en -copyToDesign\n");
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    [z setIntValue: ascrule[i0][i1]-'0'];
    z=[z nextText];
  printf("fin de -copyToDesign\n");
    }    
return self;
}

/*- enterDesign:sender {
int i, k, i0, i1, i2;
id  z;
  printf("estoy en -enterDesign\n");
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1]=(k<KK?k:0)+'0';
    auxrule[i0][i1]=(k<KK?1:0);
    }
  printf("fin de -enterDesign\n");
  [self setAllRules: self];
return self;
}*/

int permut(k,n) int k, n; {
  switch (n) {
    case 0: break;
    case 1: k=(k+1)%KK; break;
    case 2: k=(KK+k-1)%KK; break;
    case 3: if (k==1) k=2; else if (k==2) k=1; break;
    case 4: if (k==2) k=0; else if (k==0) k=2; break;
    case 5: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<24; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, k, i0, i1, i2;
int    stat[KK], statp[KK][KK];		/* statistic counts */
int    shif[RR];			/* shift counts     */
int    xe;				/* xenofhobic count */
double staf[KK], stapf[KK][KK],t, pp, qq;

xe=0;
pp=1.0/((double)(DS));
qq=pp/((double)KK);
for (i=0; i<RR; i++) shif[i]=0;
for (i=0; i<KK; i++) {stat[i]=0; for (j=0; j<KK; j++) statp[i][j]=0;}
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  j=ascrule[i0][i1]-'0';
  stat[j]++;
  if (j==i0) shif[0]++;    /* left */
  if (j==i1) shif[1]++;    /* rigth */
  if (j==i0 || j==i1 ) xe++;
  for (i2=0; i2<KK; i2++) {
      k=ascrule[i1][i2]-'0';
      statp[j][k]++;
   }
 }

// for (i=0; i<RR; i++) printf("shif[%d]=%d",i,shif[i]);

for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
for (i=0; i<RR; i++) 
      [[statIndx cellAt: i: 0] setDoubleValue: ((double)shif[i])*pp];
//[statIndx setDoubleValue: ((double)shif[0])*pp at: 0];
//[statIndx setDoubleValue: ((double)shif[1])*pp at: 1];

// for (i=0; i<RR; i++) printf("shif[%d]=%5.3f",i,((double)shif[i])*pp);


for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
[statLamb setDoubleValue: 1.0-staf[0]];
[statEntro setDoubleValue: -t/log((double)KK)];
for (i=0, t=0.0; i<KK; i++) for (j=0; j<KK; j++){
    stapf[i][j]=((double) statp[i][j])*qq;
[[statPairs cellAt: i: j] setDoubleValue: stapf[i][j]];
t+=stapf[i][j]*log(stapf[i][j]);
// printf("statpairs[%d][%d]=%5.3f",i,j,stapf[i][j]);
}
[statPEntro  setDoubleValue: -t/log((double)(KK*KK))];
// ("statPEntro=%5.3f",-t/log((double)(KK*KK)));
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
// printf("fin de -nxcafreq (trivia panel)\n");
return self;
}


/* ------------  A R I T H M E T I C   C O M B I N A T I O N ------------ */

- arithmCombs: sender {
birular aza, bzb, czc;
  printf("estoy en arithCombs\n");
  [self readWRule: [twoRules cellAt: 0: 0]];
  asctobin();
  bincopy(&aza, &binrule); 
  binprint(&aza);
  [self readWRule: [twoRules cellAt: 1: 0]];
  asctobin();
  bincopy(&bzb, &binrule);
  binprint(&bzb);
  switch ([sender selectedRow]) {
     case 0: binsum(&czc, &aza, &bzb); break;
     case 1: binprod(&czc, &aza, &bzb); break;
     default: printf("arithCombs\n"); return self;}
  printf("imprime czc\n");
  binprint(&czc);
  bincopy(&binrule,&czc);
  bintoasc();
  [self setAllRules: self];
  binprint(&binrule);
return self;
}

- initTwoRules:sender {char c[WNML];
   granrule();
   wru(c);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: c];
  return self;
 }

/* copy one binary rule from another */
void bincopy(rz,rx)  birular *rz, *rx;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=rx->one[i];}

/* fill ascrule from binrule */
void bintoasc() {int i0, i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    ascrule[i0][i1]=binrule.two[i0][i1]+'0';
}

/* sum two binary rules mod KK */
void binsum(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++)  rz->one[i]=(rx->one[i]+ry->one[i])%KK;}


/* multiply two binary rules mod KK */
void binprod(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=(rx->one[i]*ry->one[i])%KK;}

/* print a binary rule (all 25 numbers) */
void binprint(rz) birular *rz; {int i;
for(i=0; i<KK*KK; i++) printf("%c",rz->one[i]+'0');
printf("\n");
}

/* --------- REC Line from rulePanel -----------*/

- useRECLine:sender {
   [RECPanel makeKeyAndOrderFront: sender];
   [RECValue setStringValue: "*"];
   return self;
}

- runRECLine:sender {
   printf("hello from runRec\n");
   [RECValue setStringValue: " "];
   if (rec([sender stringValue]))
      [RECValue setStringValue: "T"];
     else
      [RECValue setStringValue: "F"];
    return self;
}


@end

/* end RulePanel.m */
