
/* nxardn9h.c						*/
/* program for lcau9h option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau9h.h"
# include "nxardn9h.h"

extern char ascrule[KK][KK];
extern int  binrule[KK][KK];
extern double stt, sta[][K2+1][K2+1];

int  h8[HH];

extern parneih    amat[KK];

extern twoparn    smat;
extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;


/* edit the Garden of Eden and ancestor calculation */
void edard() {
char c;
int    i, l, ll, m;
int    i0, i1, i2;
int    s0, s1, s2, s3;
int    t0, t1, t2, t3;
double bb, e, f, ff, g, gg;
double ii, ss, h, hh, kay;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[KK][KK];
double xvec[KK][KK];
double rr[3][2], k[4][2];
double stt, sta[5][K2+1][K2+1];
int a, b, s, t;
int ttsum();

  while (0<1) {
  switch (c) {

    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
	  for (i0=0; i0<K2+1; i0++)
	  for (i1=i0; i1<K2+1; i1++)
	    {f=sta[0][i0][i1]; if (f>0.0) {
	    g=sta[1][i0][i1]/f;
	    h=sta[2][i0][i1]/f;
	    e=sqrt(h-g*g);
            printf("%1u%1u %6.1f, %6.3f, %6.2f, %6.3f\n",i0,i1,f,g,h,e);
	    }}
	f=sta[0][3][3]-stt; if (f>0.0) {
	    g=(sta[1][3][3]-3.0*stt)/f;
	    h=(sta[2][3][3]-9.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.1f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.1f, %6.3f, %6.2f, %6.3f\n",stt,3.0,9.0,0.0);
	break;
//     case 'u':			/* variance of eigenvector components	*/
// 	auua(&xave,&xsig,&ex,&wy,cvec,xvec,umat);
// 	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
// 	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
// 	break;
//     case 'v':			/* variance of column sums 		*/
// 	avva(&cave,&csig,cvec,tmat);
// 	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
// 	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
        for (i0=0; i0<K2+1; i0++)
        for (i1=i0; i1<K2+1; i1++)
	  {f=sta[0][i0][i1]; if (f>0.0) {
	  e=sta[1][i0][i1]/f;
          g=sta[3][i0][i1];
          h=sta[4][i0][i1];
	  ff=((double)(i0*i0+i1*i1+(K2-i0-i1)*(K2-i0-i1)))/9.0;
          printf("%1u%1u  %6.3f, %6.3f, %6.3f, %6.3f\n",i0,i1,g,h,e,ff);
        }}
      break;
    default: break;
    } /* end switch */
  }   /* end while  */
}

/* calculate the first two moments of all rules       */
/* that would mean 5^25 repetitions of the inner loop */
void allmo() {}

/* calculate tensor square sum axa+bxb+cxc+dxd+exe+fxf */
void tensq(tmat,amat)twoparn *tmat; parneih amat[]; {
int k, i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  for (k=0; k<KK; k++) 
    tmat->four[i0][i1][i2][i3]+=
	(amat[k].two[i0][i2])*(amat[k].two[i1][i3]);
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

/* clear edard screen and set up menu */
void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("abc - 0,1 matrix\n");
  printf("ABC - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ss   - all rules\n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

void rvers(amat) parneih amat[]; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m3[KK][KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
for (i=0; i<KK; i++) cymat(&m1[i],&amat[i]);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3u,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3]);
  }
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

void histo(amat) parneih amat[]; {
parneih    xmat;
parneih    m1[KK];
parneih    m2[KK][KK];
parneih    m4[KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
for (i=0; i<KK; i++) cymat(&m1[i],&amat[i]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(&xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(&xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("ttl %4u in %4u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond:%5u,%3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);
s=1.0; if (t>1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma:   %6.2f",s);

}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

/* make a list of the reversible rules */

void rever() {
char chb[14], chc[14];
char ii[240][KK][KK][KK], wanum[240][14], wbnum[240][14];
char asqrule[KK][KK], bsqrule[KK][KK];
int kay[KK];
int         brul[KK][KK];
int         crul[KK][KK];
int     drul[KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK];

int i00,i01,i02,i03,i04,i10,i11,i12,i13,i14;
int i20,i21,i22,i23,i24,i30,i31,i32,i33,i34;
int i40,i41,i42,i43,i44;
int j0,j1,j2,j3,j4,j5;
int i, k, kk, l, m, mm, nn;
printf("hello from rever\n");
k=kk=l=m=0;
for (i=0; i<KK; i++) kay[i]=0;
i=0;
printf("reversibles - unicycles\n");
for (i00=0; i00<KK; i00++) {brul[0][0]=i00;
        if (kay[i00]>(KK*KK)) break; kay[i00]++;
for (i11=0; i11<KK; i11++) {brul[1][1]=i11;
        if (i11==i00) continue;
        if (kay[i11]>(KK*KK)) break; kay[i11]++;
for (i22=0; i22<KK; i22++) {brul[2][2]=i22;
        if (i22==i00) continue;
        if (i22==i11) continue;
        if (kay[i22]>(KK*KK)) break; kay[i22]++;

for (i33=0; i33<KK; i33++) {brul[3][3]=i33;
        if (i33==i00) continue;
        if (i33==i11) continue;
        if (i33==i22) continue;
        if (kay[i33]>(KK*KK)) break; kay[i33]++;

for (i44=0; i44<KK; i44++) {brul[4][4]=i44;
        if (i44==i00) continue;
        if (i44==i11) continue;
        if (i44==i22) continue;
        if (i44==i33) continue;
        if (kay[i44]>(KK*KK)) break; kay[i44]++;


printf("reversibles - bicycles\n");
for (i01=0; i01<KK; i01++) {brul[0][1]=i01;
         if (kay[i01]>(KK*KK)) break; kay[i01]++; 
for (i10=0; i10<KK; i10++) {brul[1][0]=i10;
         if (i01==i10) continue;
         if (kay[i10]>(KK*KK)) break; kay[i10]++;

for (i02=0; i02<KK; i02++) {brul[0][2]=i02;
         if (kay[i02]>(KK*KK)) break; kay[i02]++;
for (i20=0; i20<KK; i20++) {brul[2][0]=i20;
         if (i02==i20) continue;
         if (i02==i01&&i20==i10) continue;
         if (i02==i10&&i20==i01) continue;
         if (kay[i20]>(KK*KK)) break; kay[i20]++;

for (i03=0; i03<KK; i03++) {brul[0][3]=i03;
         if (kay[i03]>(KK*KK)) break; kay[i03]++;
for (i30=0; i30<KK; i30++) {brul[3][0]=i30;
         if (i03==i30) continue;
         if (i03==i01&&i30==i10) continue;
         if (i03==i10&&i30==i01) continue;
         if (i03==i02&&i30==i20) continue;
         if (i03==i20&&i30==i02) continue;
         if (kay[i30]>(KK*KK)) break; kay[i30]++;

for (i04=0; i04<KK; i04++) {brul[0][4]=i04;
         if (kay[i04]>(KK*KK)) break; kay[i04]++;
for (i40=0; i40<KK; i40++) {brul[4][0]=i40;
         if (i04==i40) continue;
         if (i04==i01&&i40==i10) continue;
         if (i04==i10&&i40==i01) continue;
         if (i04==i02&&i40==i20) continue;
         if (i04==i20&&i40==i02) continue;
         if (i04==i03&&i40==i30) continue;
         if (i04==i30&&i40==i03) continue;
         if (kay[i40]>(KK*KK)) break; kay[i40]++;



for (i12=0; i12<KK; i12++) {brul[1][2]=i12;
         if (kay[i12]>(KK*KK)) break; kay[i12]++;
for (i21=0; i21<KK; i21++) {brul[2][1]=i21;
         if (i12==i21) continue;
         if (i12==i01&&i21==i10) continue;
         if (i12==i10&&i21==i01) continue;
         if (i12==i02&&i21==i20) continue;
         if (i12==i20&&i21==i02) continue;
         if (i12==i03&&i21==i30) continue;
         if (i12==i30&&i21==i03) continue;
         if (i12==i04&&i21==i40) continue;
         if (i12==i40&&i21==i04) continue;
         if (kay[i21]>(KK*KK)) break; kay[i21]++;



for (i13=0; i13<KK; i13++) {brul[1][3]=i13;
         if (kay[i13]>(KK*KK)) break; kay[i13]++;
for (i31=0; i31<KK; i31++) {brul[3][1]=i31;
         if (i13==i31) continue;
         if (i13==i01&&i31==i10) continue;
         if (i13==i10&&i31==i01) continue;
         if (i13==i02&&i31==i20) continue;
         if (i13==i20&&i31==i02) continue;
         if (i13==i03&&i31==i30) continue;
         if (i13==i30&&i31==i03) continue;
         if (i13==i04&&i31==i40) continue;
         if (i13==i40&&i31==i04) continue;
         if (i13==i12&&i31==i21) continue;
         if (i13==i21&&i31==i12) continue;
         if (kay[i31]>(KK*KK)) break; kay[i31]++;


for (i14=0; i14<KK; i14++) {brul[1][4]=i14;
         if (kay[i14]>(KK*KK)) break; kay[i14]++;
for (i41=0; i41<KK; i41++) {brul[4][1]=i41;
         if (i14==i41) continue;
         if (i14==i01&&i41==i10) continue;
         if (i14==i10&&i41==i01) continue;
         if (i14==i02&&i41==i20) continue;
         if (i14==i20&&i41==i02) continue;
         if (i14==i03&&i41==i30) continue;
         if (i14==i30&&i41==i03) continue;
         if (i14==i04&&i41==i40) continue;
         if (i14==i40&&i41==i04) continue;
         if (i14==i12&&i41==i21) continue;
         if (i14==i21&&i41==i12) continue;
         if (i14==i13&&i41==i31) continue;
         if (i14==i31&&i41==i13) continue;

         if (kay[i41]>(KK*KK)) break; kay[i41]++;

for (i23=0; i23<KK; i23++) {brul[2][3]=i23;
         if (kay[i23]>(KK*KK)) break; kay[i23]++;
for (i32=0; i32<KK; i32++) {brul[3][2]=i32;
         if (i23==i32) continue;
         if (i23==i01&&i32==i10) continue;
         if (i23==i10&&i32==i01) continue;
         if (i23==i02&&i32==i20) continue;
         if (i23==i20&&i32==i02) continue;
         if (i23==i03&&i32==i30) continue;
         if (i23==i30&&i32==i03) continue;
         if (i23==i04&&i32==i40) continue;
         if (i23==i40&&i32==i04) continue;
         if (i23==i12&&i32==i21) continue;
         if (i23==i21&&i32==i12) continue;
         if (i23==i13&&i32==i31) continue;
         if (i23==i31&&i32==i13) continue;
         if (i23==i14&&i32==i41) continue;
         if (i23==i41&&i32==i14) continue;

         if (kay[i32]>(KK*KK)) break; kay[i32]++;

for (i24=0; i24<KK; i24++) {brul[2][4]=i24;
         if (kay[i24]>(KK*KK)) break; kay[i24]++;
for (i42=0; i42<KK; i42++) {brul[4][2]=i42;
         if (i24==i42) continue;
         if (i24==i01&&i42==i10) continue;
         if (i24==i10&&i42==i01) continue;
         if (i24==i02&&i42==i20) continue;
         if (i24==i20&&i42==i02) continue;
         if (i24==i03&&i42==i30) continue;
         if (i24==i30&&i42==i03) continue;
         if (i24==i04&&i42==i40) continue;
         if (i24==i40&&i42==i04) continue;
         if (i24==i12&&i42==i21) continue;
         if (i24==i21&&i42==i12) continue;
         if (i24==i13&&i42==i31) continue;
         if (i24==i31&&i42==i13) continue;
         if (i24==i14&&i42==i41) continue;
         if (i24==i41&&i42==i14) continue;
         if (i24==i23&&i42==i32) continue;
         if (i24==i32&&i42==i23) continue;

         if (kay[i42]>(KK*KK)) break; kay[i42]++;


for (i34=0; i34<KK; i34++) {brul[3][4]=i34;
         if (kay[i34]>(KK*KK)) break; kay[i34]++;
for (i43=0; i43<KK; i43++) {brul[4][3]=i43;
         if (i34==i43) continue;
         if (i34==i01&&i43==i10) continue;
         if (i34==i10&&i43==i01) continue;
         if (i34==i02&&i43==i20) continue;
         if (i34==i20&&i43==i02) continue;
         if (i34==i03&&i43==i30) continue;
         if (i34==i30&&i43==i03) continue;
         if (i34==i04&&i43==i40) continue;
         if (i34==i40&&i43==i04) continue;
         if (i34==i12&&i43==i21) continue;
         if (i34==i21&&i43==i12) continue;
         if (i34==i13&&i43==i31) continue;
         if (i34==i31&&i43==i13) continue;
         if (i34==i14&&i43==i41) continue;
         if (i34==i41&&i43==i14) continue;
         if (i34==i23&&i43==i32) continue;
         if (i34==i23&&i43==i23) continue;
         if (i34==i24&&i43==i42) continue;
         if (i34==i42&&i43==i24) continue;

         if (kay[i43]>(KK*KK)) break; kay[i43]++;


        kk++;

  if (runiq(brul,crul)) {
             byntoasc(asqrule,brul);
             byntoasc(bsqrule,crul);
             mm=allperm(wanum,ii,asqrule);
             nn=allperm(wbnum,ii,bsqrule);
             wrru(chb,asqrule);
             wrru(chc,bsqrule);
             printf("runiq: %s   %s   %s  %s (%3d)/%3d\n",
                    wanum[mm],chb,chc,wbnum[nn],++k,kk);
             kk=0;
        }

  kay[i43]--;}
  kay[i34]--;}
  kay[i42]--;}
  kay[i24]--;}
  kay[i32]--;}
  kay[i23]--;}

  kay[i41]--;}
  kay[i14]--;}
  kay[i31]--;}
  kay[i13]--;}
  kay[i21]--;}
  kay[i12]--;}
  kay[i40]--;}
  kay[i04]--;}
  kay[i30]--;}
  kay[i03]--;}
  kay[i20]--;}
  kay[i02]--;}

  kay[i10]--;}
  kay[i01]--;}
  kay[i44]--;}
  kay[i33]--;}
  kay[i22]--;}
  kay[i11]--;}
  kay[i00]--;}

 }

int runiq(crul,brul) int crul[KK][KK], brul[KK][KK]; {
int a, b;
int j0, j1, j2;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) crul[j0][j1]=KK;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) for (j2=0; j2<KK; j2++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  if (crul[a][b]==KK) crul[a][b]=j1;
  if (crul[a][b]!=j1) return(0);
  }
return(1);
}

int suniq(drul,brul) int brul[KK][KK], drul[KK][KK][KK][KK]; {
int a, b, e, f;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  drul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  if (drul[a][b][e][f]==KK) drul[a][b][e][f]=j2;
  if (drul[a][b][e][f]!=j2) return(0);
  }
return(1);
}

int tuniq(erul,brul) int brul[KK][KK], erul[KK][KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  erul[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  g=brul[j4][j5];
  h=brul[j5][j6];
  if (erul[a][b][e][f][g][h]==KK) erul[a][b][e][f][g][h]=j3;
  if (erul[a][b][e][f][g][h]!=j3) return(0);
  }
return(1);
}

/* fill ascrule from binrule */
void byntoasc(as,bi) char as[KK][KK]; int bi[KK][KK]; 
{int i0, i1; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
    as[i0][i1]=bi[i0][i1]+'0';
}

/* fill (3,3/2) ascrule from (3,3/2) binrule */
void bynthtoasc(as,bi) char as[KK][KK][KK][KK]; int bi[KK][KK][KK][KK]; 
{int i0, i1, i2, i3; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
    as[i0][i1][i2][i3]=bi[i0][i1][i2][i3]+'0';
}

/* fill (3,5/2) ascrule from (3,5/2) binrule */
void bynfhtoasc(as,bi) char as[KK][KK][KK][KK][KK][KK];
		        int bi[KK][KK][KK][KK][KK][KK]; 
{int i0, i1, i2, i3, i4, i5; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) 
    as[i0][i1][i2][i3][i4][i5]=bi[i0][i1][i2][i3][i4][i5]+'0';
}

/* print matrix */
void pmat(z) parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {printf("%1d",z->two[i0][i1]);}
}

/* print matrix */
void ppmat(z) twoparn *z; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%4u",z->four[i0][i1][i2][i3]);
  }
}

/* display K4xK4 matrix */
void qqmat(z) twoparn *z; {
int i0, i1, k, l;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {
  k=0; l=z->two[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i0,i1,k);
  }
}

/* total matrix elements */
int tsum(z) parneih *z; 
{int t, i; for (i=0, t=0; i<K2; i++) t+=z->one[i]; return t;}

/* total matrix elements */
int ttsum(z) twoparn *z; 
{int t, i; for (i=0, t=0; i<K4; i++) t+=z->one[i]; return t;}

/* count nonzero matrix elements */
int nzel(z) parneih *z; 
{int t, i; for (i=0, t=0; i<K2; i++) if (z->one[i]!=0) t++; return t;}

/* count nonzero matrix elements */
int nnzel(z) twoparn *z; 
{int t, i; for (i=0, t=0; i<K4; i++) if (z->one[i]!=0) t++; return t;}

/* calculate row sums */
void rowsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (i0=0; i0<KK; i0++) {
  x[i0]=0;
  for (j0=0; j0<KK; j0++) x[i0]+=z->two[i0][j0];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK]; parneih *z; {int i0, j0;
for (j0=0; j0<KK; j0++) {
  x[j0]=0;
  for (i0=0; i0<KK; i0++) x[j0]+=z->two[i0][j0];
  }
}

/* copy one KKxKK matrix from another: z=x */
void cymat(z,x) parneih *z, *x; {
int i; for (i=0; i<K2; i++) z->one[i]=x->one[i];
}

/* copy one K2xK2 matrix from another: z=x */
void ccymat(z,x) twoparn *z, *x; {
int i; for (i=0; i<K4; i++) z->one[i]=x->one[i];
}

/* multiply matrices */
void mmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i0][i1]*y->two[i1][i2];
      }
}

/* multiply transpose of first matrix by second */
void mtmat(z,x,y) parneih *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* multiply matrices */
void mmmat(z,x,y) twoparn *z, *x, *y; {
int i0, i1, i2, i3, i4, i5;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z->four[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	z->four[i0][i1][i4][i5]+=x->four[i0][i1][i2][i3]*y->four[i2][i3][i4][i5];
      }
}

/* multiply transpose of first K2xK2 matrix by second */
void mmtmat(z,x,y) twoparn *z, *x, *y; {
int i0,i1,i2;
    for (i0=0; i0<K2; i0++)
    for (i2=0; i2<K2; i2++)
      {
      z->two[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z->two[i0][i2]+=x->two[i1][i0]*y->two[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l; parneih *z; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->two[i0][i1]=(binrule[i0][i1]==l)?1:0;
}

/* zero a KKxKK matrix */
void zmat(z) parneih *z; {
int i; for (i=0; i<K2; i++) z->one[i]=0;
}

/* generate a K2xK2 unit matrix */
void unmat(z) twoparn *z; {
int i0, i1;
  zzmat(z);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z->four[i0][i1][i0][i1]=1;
}

/* zero a K2xK2 matrix */
void zzmat(z) twoparn *z; {
int i; for (i=0; i<K4; i++) z->one[i]=0;
}

/* average and variance of eigenvector components */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 twoparn *mat; {
int    i, j;
double a, v, p, q, r, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[j][i];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
for (i=0; i<K2; i++) vec[i]/=a;
a=1.0/kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K2; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk2);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; twoparn *mat; {
int    i, j;
double a, v, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat->two[i][j];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
a/=kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk2);
}


/* end  nxardn9h.c */
